CREATE OR REPLACE VIEW Layers_NonSynchr
(LayerRef,LayerVersion,Assembly)
AS
Select ld.INTFIELD00 LayerRef, ld.INTFIELD01 LayerVersion, ld.INTFIELD02 Assembly from LayerData ld
    inner join Layers l on (ld.LayerRef=l.ID)
where (l.alias = '..');




CREATE OR REPLACE VIEW Layers_ForURM
(LayerRef,UserName,CLIENTID)
AS
  
select l.ID,dbu.USERNAME,rc.ClientID
FROM LAYERS l

INNER JOIN REMOTECLIENT rc ON 1=1

INNER JOIN DBUSERS dbu ON dbu.REMOTECLIENTREF=rc.ID


LEFT JOIN (
    select dbu.ID UserID,ld_GroupForbid.STRFIELD02 Alias
    FROM LayerData ld_GroupForbid
    INNER JOIN DBGroups dbg
      ON (ld_GroupForbid.STRFIELD00=dbg.Name)
        AND (ld_GroupForbid.INTFIELD03=0)
        AND ld_GroupForbid.LAYERREF=(select lg.ID from Layers lg where 
lg.ALIAS='..')


    INNER JOIN USERSINGROUPS uig
      ON uig.GroupRef=dbg.ID
    INNER JOIN DBUSERS dbu
      ON uig.UserRef=dbu.ID
  ) GrForbid ON
    GrForbid.UserID=dbu.ID AND GrForbid.Alias=l.Alias


  LEFT JOIN (
   SELECT ld_UserForbid.STRFIELD02 UserName,ld_UserForbid.STRFIELD01 Alias
    FROM LayerData ld_UserForbid
    WHERE ld_UserForbid.LAYERREF=(
         select lu.ID from Layers lu where 
lu.ALIAS='..'
     )
     AND
     (ld_UserForbid.INTFIELD03=0)
   ) UserForbid
   ON (UserForbid.UserName=dbu.UserName||'@'||rc.CLIENTID)
     AND (UserForbid.Alias=l.Alias)
WHERE
   UserForbid.UserName is NULL
   AND
   GrForbid.UserID is NULL;


COMMIT WORK;

